

#include <tigcclib.h>         // Include All Header Files
#include "cgl.h"







fl0at grid[20][20];
float fgrid[20][20];

short display_dirty;

void init()
{

	display_dirty = TRUE;


	if( GL_INIT() ) {
		exit(-1);
	}


	glViewport(1, 1, BACK_BUFFER_WIDTH - 2, BACK_BUFFER_HEIGHT -2);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0f, (float) LCD_WIDTH/ (float) LCD_HEIGHT, 1.0 ,100.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(45, 10, 45,     10, -20, 10,     0, 1, 0);

	glClearColor(3);

	short x,z;

	printf("generating height map\n");

	for(x = 0; x < 20; x++){
		for(z = 0; z < 20; z++){

			float a = (((float)x-10.0)/3.3);
			float b = (((float)z-10.0)/3.3);

			fgrid[x][z] = 3.0 * cos( a * a  + b * b );
			grid[x][z] = float_to_fl0at(  fgrid[x][z] );

		}

		printf("  %i/20 rows, %i triangles\n", x + 1, (x+1) * 40);
	}

}





void input()
{

	const float LINEAR_SPEED = 13.0;
	const float ANGULAR_SPEED = 20.0;

	short esc = FALSE;

	float y_rotation = 0;
	float z_translation = 0;

	BEGIN_KEYTEST

		y_rotation -= _keytest_optimized (RR_LEFT) * ANGULAR_SPEED;
		y_rotation += _keytest_optimized (RR_RIGHT) * ANGULAR_SPEED;

		z_translation += _keytest_optimized (RR_UP) * LINEAR_SPEED;
		z_translation -= _keytest_optimized (RR_DOWN) * LINEAR_SPEED;

		esc = _keytest_optimized (RR_ESC);

	END_KEYTEST


	float m[16];

	if( y_rotation != 0 ) {

		glGetFloatv(GL_MODELVIEW_MATRIX, m);
		glLoadIdentity();
		glRotatef(y_rotation, m[4], m[5], m[6]);
		glMultMatrixf(m);

		display_dirty = TRUE;
	}


	if( z_translation != 0 ) {

		glGetFloatv(GL_MODELVIEW_MATRIX, m);
		float length = sqrt( m[2] * m[2] + m[10] * m[10] );
		z_translation /= length;
		glTranslatef(z_translation * m[2], 0 /*3 * m[6]*/, z_translation * m[10]);

		display_dirty = TRUE;
	}


	if(esc){

		GL_DEINIT();
		exit(0);
	}


}





void update()
{


}










void render()
{
	if(display_dirty == FALSE){
		return;
	}


	display_dirty = FALSE;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	short x,z;

	glCullFace(GL_BACK);
	glFrontFace(GL_CCW);
	glEnable(GL_CULL_FACE);



	glPolygonOffset(0);

	glShadeModel(GL_SMOOTH);


	SwapBuffers();

	glPushMatrix();

	glScalef(2.5,0.75,2.5);

	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);


	for(x = 0; x < 19; x++){

		glBegin(GL_QUAD_STRIP);

		for(z = 0; z < 20; z++){


			glColor( ((x) % 3 + 1) * 40 + fl0at_to_short( flmult( ( fladd( grid[x+1][z] , make_fl0at_s( 5) ) ) , make_fl0at_s( 13) ) ) );
			glVertex3f0(
				make_fl0at_s(x+1),
				grid[x+1][z],
				make_fl0at_s(z) );

			glColor( ((x) % 3 + 1) * 40 + fl0at_to_short( flmult( ( fladd( grid[x][z] , make_fl0at_s( 5) ) ) , make_fl0at_s( 13) ) ) );
			glVertex3f0(
				make_fl0at_s(x),
				grid[x][z],
				make_fl0at_s(z) );
		}

		glEnd();


	}

	SwapBuffers();




	glPolygonOffset(-100);
	glEnable(GL_POLYGON_OFFSET_LINE);





	glColor(black);


	for(z = 0; z < 20; z++){

		glBegin(GL_LINE_STRIP);

		for(x = 0; x < 20; x++){
			glVertex3f0( make_fl0at_s(x) , grid[x][z], make_fl0at_s(z) );
		}

		glEnd();

	}






	for(x = 0; x < 20; x++){

		glBegin(GL_LINE_STRIP);

		for(z = 0; z < 20; z++){
			glVertex3f0( make_fl0at_s(x) , grid[x][z], make_fl0at_s(z) );
		}

		glEnd();

	}





	glPopMatrix();

	SwapBuffers();

	glEnd();
}





void _main(void)
{

	init();


	while(1){
		input();
		update();
		render();
	}
}
